# Bubble sort that sorts a list into ascending order
def bubbleSort(myList):
    for lastUnsortedIndex in range(len(myList)-1,0,-1):
        for testIndex in range(lastUnsortedIndex):
            if myList[testIndex]>myList[testIndex+1]:
                # swap if out of order
                temp = myList[testIndex]
                myList[testIndex] = myList[testIndex+1]
                myList[testIndex+1] = temp


# Bubble sort that sorts a list into ascending order
# This version includes a check to see if we can stop early
def shortBubbleSort(myList):
    exchanges = True
    lastUnsortedIndex = len(myList)-1
    while lastUnsortedIndex > 0 and exchanges:
       exchanges = False
       for testIndex in range(lastUnsortedIndex):
           if myList[testIndex]>myList[testIndex+1]:
               exchanges = True
               # swap if out of order
               temp = myList[testIndex]
               myList[testIndex] = myList[testIndex+1]
               myList[testIndex+1] = temp
               
       lastUnsortedIndex -= 1


# Selection sort that sorts a list into ascending order
def selectionSort(myList):
    #outer loop keeps track of the dividing line between
    #the sorted and unsorted part of myList
    for lastUnsortedIndex in range(len(myList)-1, 0, -1):
        # search of the largest item in the unsorted
        # part of myList, i.e., myList[0 .. lastUnsortedIndex]

        # Assume the first item is the largest
        maxIndex = 0
        # Correct the assumption by looking for a larger item
        for testIndex in range(1, lastUnsortedIndex+1):
            if myList[testIndex] > myList[maxIndex]:
                maxIndex = testIndex

        # Now, maxIndex is the location of the largest
        # item in the unsorted part, so "swap" it with
        # the last unsorted item to extend the sorted part
        temp = myList[maxIndex]
        myList[maxIndex] = myList[lastUnsortedIndex]
        myList[lastUnsortedIndex] = temp
                

# Insertion Sort that sorts a list in ascending order
def insertionSort(myList):
    for firstUnsortedIndex in range(1, len(myList)):
        # copy the first unsorted element
        temp = myList[firstUnsortedIndex]
        # scan the sorted part from right to left looking
        # for the correct spot to insert the first unsorted element
        testIndex = firstUnsortedIndex - 1
        while testIndex >= 0 and temp < myList[testIndex]:
            # slide the element to the right to make room for the
            # inserted element
            myList[testIndex+1] = myList[testIndex]
            testIndex = testIndex - 1

        # after  finding the correct spot insert the element
        myList[testIndex + 1] = temp


# Recursive merge sort code to sort in ascending order
def mergeSort(myList):
    # print "Start of mergeSort", myList
    if len(myList)>1:
        middle = len(myList)/2
        leftHalf = myList[:middle]
        rightHalf = myList[middle:]

        mergeSort(leftHalf)
        mergeSort(rightHalf)
        merge(myList, leftHalf, rightHalf)
    # print "End of mergeSort", myList

def merge(sortedList, leftHalf, rightHalf):
    # both the leftHalf and rightHalf lists are sorted
    left = 0
    right = 0
    sortedIndex = 0
    # loop until one list runs out
    while left < len(leftHalf) and right < len(rightHalf):
        if leftHalf[left] > rightHalf[right]:
            sortedList[sortedIndex] = rightHalf[right]
            right += 1
        else:
            sortedList[sortedIndex] = leftHalf[left]
            left += 1

        sortedIndex += 1

    # copy the remaining items in the leftHalf
    while left < len(leftHalf):
        sortedList[sortedIndex] = leftHalf[left]
        left += 1

    # copy the remaining items in the rightHalf
    while right < len(rightHalf):
        sortedList[sortedIndex] = rightHalf[right]
        right += 1


# Recursive merge sort code to sort in ascending order
# Merges the halves by appending to the sorted list
def mergeSortB(myList):
    # print "Start of mergeSort", myList
    if len(myList)>1:
        middle = len(myList)/2
        leftHalf = myList[:middle]
        rightHalf = myList[middle:]

        sortedLeftHalf = mergeSortB(leftHalf)
        sortedRightHalf = mergeSortB(rightHalf)
        sortedList = mergeB(sortedLeftHalf, sortedRightHalf)
        # print "End of mergeSort", myList
        return sortedList
    # print "End of mergeSort", myList
    return myList
    

def mergeB(leftHalf, rightHalf):
    # both the leftHalf and rightHalf lists are sorted
    left = 0
    right = 0
    sortedList = []
    # loop until one list runs out
    while left < len(leftHalf) and right < len(rightHalf):
        if leftHalf[left] > rightHalf[right]:
            sortedList.append(rightHalf[right])
            right += 1
        else:
            sortedList.append(leftHalf[left])
            left += 1

    # copy the remaining items in the leftHalf
    while left < len(leftHalf):
        sortedList.append(leftHalf[left])
        left += 1

    # copy the remaining items in the rightHalf
    while right < len(rightHalf):
        sortedList.append(rightHalf[right])
        right += 1

    return sortedList

